=== debian/changelog ===
muse (3.0.2.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>  Thu, 28 Jan 2021 20:00:43 +0800
