=== debian/changelog ===
muse (3.1.0-0.1~mx19+1) mx; urgency=medium

  * New upstream release.
  * Update build dependencies based on new requirements.
  * Refresh 0001-Use-a-more-consistent-versioning.patch and 
    0002-Add-f-option-to-desktop-file-Exec-key.patch
  * Drop other patches to fix compilation with Qt 5.11, fixed upstream.
  
 -- Steven Pusser <stevep@mxlinux.org>  Mon, 25 May 2020 12:03:06 -0700
