=== debian/control ===
Source: muse
Section: sound
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>,
 Fabrice Coutadeur <coutadeurf@gmail.com>
Build-Depends:
 cmake (>= 2.4),
 debhelper (>= 11),
 dssi-dev,
 ladspa-sdk,
 libasound2-dev,
 libdssialsacompat-dev [!linux-any],
 libfluidsynth-dev (>= 1.0.3),
 libgtkmm-2.4-dev,
 libjack-jackd2-dev,
 libinstpatch-dev,
 liblilv-dev (>= 0.22),
 liblo-dev,
 libqt5svg5-dev (>= 5.7.0),
 liblrdf0-dev,
 librtaudio-dev,
 libsamplerate0-dev (>= 0.1.0),
 libsndfile1-dev (>= 1.0.1),
 libsord-dev (>= 0.14),
 lv2-dev (>= 1.12),
 qtbase5-dev (>= 5.7.0),
 qttools5-dev (>= 5.7.0)
Standards-Version: 4.2.1
Homepage: http://www.muse-sequencer.org/
Vcs-Git: https://salsa.debian.org/multimedia-team/muse.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/muse

Package: muse
Architecture: any
Depends:
 python,
 python3,
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 jackd
Description: Qt-based audio/MIDI sequencer
 MusE is a MIDI/audio sequencer with recording and editing capabilities.
 Some Highlights:
 .
  * Standard midifile (smf) import-/export.
  * Organizes songs in tracks and parts which you can arrange with
    the part editor.
  * MIDI editors: pianoroll, drum, list, controller.
  * Score editor with high quality postscript printer output.
  * Realtime: editing while playing.
  * Unlimited number of open editors.
  * Unlimited undo/redo.
  * Realtime and step-recording.
  * Multiple MIDI devices.
  * Unlimited number of tracks.
  * Sync to external devices: MTC/MMC, Midi Clock, Master/Slave.
  * Audio tracks, LADSPA host for master effects.
  * Multithreaded.
  * Uses raw MIDI devices.
  * XML project file.
  * Project file contains complete app state (session data).
  * Application spanning Cut/Paste Drag/Drop.
