=== debian/rules ===
--- 
+++ 
@@ -19,3 +19,6 @@
 		mv muse_html/single/documentation/ html/ && \
 		rm -rf muse_html
 	dh_install --remaining-packages
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
